-- Test driver for CRC class
-- Public domain (1996-09)

class CRC_TEST inherit ARGUMENTS end

creation make

feature 
	
	make is
		local
			crc : CRC16
			cnt : INTEGER
			str : STRING
		do
			!!crc.make

			if argument_count = 1 then
				if argument(1).is_equal("-") then -- CRC stdin
					from 
						crc.reset
						cnt := 0
					until io.end_of_file loop
						io.read_character
						crc.append_byte(io.last_character.code)
						cnt := cnt + 1
					end
					io.error.put_string("CRC: ")
					io.error.put_integer(crc.value)
					io.error.put_string(" (")
					io.error.put_integer(cnt)
					io.error.put_string(" characters)")
				elseif argument(1).is_equal("=") then
					crc.reset
					from cnt := 50000 until cnt = 0 loop
						crc.append_string("123456789_123456789_123456789")
						cnt := cnt - 1
					end
					io.put_integer(crc.value)
				else -- CRC first argument
					crc.reset
					crc.append_string(argument(1))
					io.put_string("CRC: ")
					io.put_integer(crc.value)
					io.put_string(" (")
					io.put_string(argument(1))
					io.put_string(")")
					io.put_new_line
				end
			else -- self test
				crc.reset
				crc.append_string("CRC_test 123456789")
				io.put_integer(crc.value)
				check valid_crc_16: crc.value = 14968 end
			end

		end

end -- class CRC_TEST